<form [formGroup]="form">
  <label [attr.for]="formCtrl.key">{{ formCtrl.label }}</label>
  <div [ngSwitch]="formCtrl.controlType">
    <input
      class="form-control"
      *ngSwitchCase="'textbox'"
      [formControlName]="formCtrl.key"
      [id]="formCtrl.key"
      [type]="formCtrl.type"
    />

    <select
      class="form-control"
      *ngSwitchCase="'dropdown'"
      [formControlName]="formCtrl.key"
      [id]="formCtrl.key"
      [value]="0"
    >
      <option disabled value="0">Select</option>
      <option *ngFor="let opt of formCtrl.options" [value]="opt.key">
        {{ opt.value }}
      </option>
    </select>

    <div class="error-msg" *ngIf="!isValid && submitted">
      <span *ngIf="form.controls[formCtrl.key].errors?.required">
        {{ formCtrl.label }} is required <br />
      </span>
      <span *ngIf="form.controls[formCtrl.key].hasError('minlength')">
        {{ formCtrl.label }} should be at least
        {{ formCtrl.minLength }} characters long. <br />
      </span>
      <span *ngIf="form.controls[formCtrl.key].hasError('maxlength')">
        {{ formCtrl.label }} cannot be more that
        {{ formCtrl.maxLength }} characters. <br />
      </span>
      <span *ngIf="form.controls[formCtrl.key].errors?.pattern">
        {{ formCtrl.label }} pattern doesnot match. <br />
      </span>
    </div>
  </div>
</form>
